/* Popbiff --- pop3 biff client */
/* 2000/02/16 Ver.1.x */
/* Freesoft GPL */
/* Programmer K.Mori(COW) */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>

extern int errno;

int main(argc, argv)
int argc;
char **argv;
{
  char c;
  FILE *fp,*pw;
  char hostname[64],username[64],pwfile[64],password[64],sstrs[64],rstrs[2048];
  char l[64],opt[3],version[10]={"1.2.0"};
  register int i,s;
  int m,n,mode;
  struct hostent *hp;
  struct sockaddr_in sin;

  mode = 0;

  /* argc check */
  if ((argc < 4)||(argc > 5)) {
    /* print version */
    fprintf(stderr, "-%s- Pop3 biff client.Ver.%s Copyright 1999(C)COW\n",argv[0],version);
    fprintf(stderr, " Usage: %s pop3_hostname username password_file [option]\n",argv[0]);
    fprintf(stderr, " option: n ... normal mode\n"
	            "         d ... debug mode\n"
	            "         h ... headder mode\n"
	            "         r ... read mode\n"
	            "         c ... return message count mode\n"
	            "         k ... delete all message mode\n");
    exit(-1);
  }
  /* set hostname */
  /* gethostname(hostname, sizeof(hostname));*/
  strcpy(hostname,argv[1]);
  /* set username */
  strcpy(username,argv[2]);
  /* set password file */
  strcpy(pwfile,argv[3]);
  /* set option */
  if (argc == 5) {
    strcpy(opt,argv[4]);
    if (strcmp(opt,"c") == 0) mode = 1; /* set count mode */
    if (strcmp(opt,"d") == 0) mode = 2; /* set debug mode */
    if (strcmp(opt,"h") == 0) mode = 3; /* set headder mode */
    if (strcmp(opt,"r") == 0) mode = 4; /* set read mode */
    if (strcmp(opt,"k") == 0) mode = 5; /* set delete mode */
  }
  /* print version */
  if (mode > 1) printf("-%s- Pop3 biff client.Ver.%s Copyright 1999(C)COW\n",argv[0],version);

  /* get password from file */
  if((pw = fopen(pwfile, "r")) == NULL) {
    fprintf(stderr,"Can not open password file\n");
    exit(-1);
  }
  fgets(password,63,pw);
  fclose(pw);

  /* look up the network address */
  if ((hp = gethostbyname(hostname)) == NULL) {
    fprintf(stderr, "%s: unknown host.\n", hostname);
    exit(-1);
  }

  /* get a socket to work with. */
  if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("client: socket");
    exit(-1);
  }

  /* create the address we will be connecting to. */
  /* use pop3 port 110 */
  sin.sin_family = AF_INET;
  sin.sin_port = htons(110);
  bcopy(hp->h_addr, &sin.sin_addr, hp->h_length);
  /* try to connect to the address. */
  if (connect(s, &sin, sizeof(sin)) < 0) {
    perror("client: connect");
    exit(-1);
  }

  /* open reading the socket. */
  fp = fdopen(s, "r");

  /* first read some strings. */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);
  if (mode == 2) printf("-Connected to %s\n",hostname);

  /* send username */
  strcpy(sstrs,"USER ");
  strcat(sstrs,username);
  strcat(sstrs,"\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  if (mode == 2) printf("-Send username.\n");
  /* read response */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);

  /* send password */
  strcpy(sstrs,"PASS ");
  strcat(sstrs,password);
  strcat(sstrs,"\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  if (mode == 2) printf("-Send password.\n");
  /* read response */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);

  /* get status */
  strcpy(sstrs,"STAT\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  if (mode == 2) printf("-Get status.\n");
  /* read response */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);
  sscanf(rstrs,"%s %d %d",&l,&m,&n);

  /* get message */
  if ((m > 0)&&(mode > 2)&&(mode < 5)) {
    for (i=1; i<m+1 ;i++){
      printf("-%d------------------\n",i);
      sprintf(sstrs,"RETR %d\r\n",i);
      send(s,sstrs,strlen(sstrs), 0);
      /* read response */
      fgets(rstrs, 2048, fp);
      if (popcheck(rstrs)) exit(-1);
      do {
	fgets(rstrs, 2048, fp);
	if(mode == 4) printf("%s",rstrs);
	else {
	  if(strncmp(rstrs,"From:",5)==0) printf("%s",rstrs);
	  if(strncmp(rstrs,"To:",3)==0) printf("%s",rstrs);
	  if(strncmp(rstrs,"Subject:",8)==0) printf("%s",rstrs);
	}
      }while(strncmp(rstrs,".",1) != 0);
    }
    printf("-end----------------\n");
  }
  if(mode == 5) {
    if(m > 0) {
     for(i=m;i>0;i--) {
      /* delete message */
      sprintf(sstrs,"DELE %d\r\n\r\n",i);
      send(s,sstrs,strlen(sstrs),0);
      /* read response */
      fgets(rstrs, 2048, fp);
      if (popcheck(rstrs)) exit(-1);
      printf("-Delete message %d at %s@%s -\n",i,username,hostname);
     }
     m=0;
    } else printf("-Can not delete message at %s@%s -\n",username,hostname);
  }
  /* quit pop3 server*/
  strcpy(sstrs,"QUIT\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  if (mode == 2) printf("-Quit.\n");
  /* read response */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);

  close(s);
  if (mode != 1) {
    printf("You have %d messages at %s@%s\n\n",m,username,hostname);
  } else {
    printf("%d\n",m);
  }

  exit(0);
}

int popcheck(strs)
char strs[];
{
  if(strs[0] == '+') return 0;
  else {
    fprintf(stderr,"-ERROR Stop\n");
    return -1;
  }
}
